#!/bin/bash

log_file='/home/pi/ADMIN/.log/serial.log'
fifo_file='/tmp/serial.fifo'
path='/dev/ttyACM'

[ ! -f "$log_file" ] && touch "$log_file"; sudo chmod 775 "$log_file"

echo -e "`date +%F`\n_______________________________________________________________\n" | sudo tee "$log_file" &>/dev/null

while IFS=$'\n' read line; do
  if [[ ${#line} -gt 1 ]]; then
    INBOX="$line"; nom='TEENSY'; dev=1; response=''

    if [[ ${INBOX:1:1} == ':' ]]; then
      [[ ${INBOX:0:1} =~ ^[0-9]+$ ]] && [[ ${INBOX:0:1} < 1 ]] && { nom='RPPICO'; dev=0; }
      INBOX="${INBOX:2}"
    fi

    if [ -c "$path$dev" ]; then
      stty -F "$path$dev" 9600 raw -echok -icanon -echo  min 0 time 30 && printf "$INBOX;" > "$path$dev"
      response=$(head -n1 "$path$dev" | sed -z 's/\n//g' | col -b)
      #response=$(head -n1 "$path$dev" | sed -z 's/\n//g' | cat -v)
      #response=$(head -n1 "$path$dev" | sed -z 's/\n//g; s/\r//g')

      entry="[ `date +%T` ] RPI > $nom: '$INBOX'\n             RPI < $nom: '$response'\n             --------------------------------------------------"
      offset=$(grep -n -m1 '^_.*' serial.log)
      sudo sed -n -i "p;$(( ${offset%%:*} + 1 ))a ${entry}" "$log_file"

      #echo -e "[ `date +%T` ] RPI > $nom: '$INBOX'\n             RPI < $nom: '$response'\n             --------------------------------------------------" | sudo tee -a "$log_file" &> /dev/null; sleep 0.5
    fi
  fi
done< <( cat <>"$fifo_file" )


